/** 
 * ASL Script for LiveSplit
 * Game: Sonic the Hedgehog (SMS)
 * Author: icy (https://www.speedrun.com/user/icy_)
 * Notes:
 *	- Only Supports "Sonic The Hedgehog (USA, Europe).sms" version of the game running in Fusion 3.64
 *	- If you experience any problems or have questions, send me a twitch whisper (https://www.twitch.tv/icy_vg)
 *	- You have to manually setup 18 splits for the auto splitter to do it's work
 *	- Splits according to SRC rules
 *	- If in LiveSplit layout settings "Game Time" is selected, the timing is RTA-TimeBonus
 *	- The "Game Time" timing method may be a bit inaccurate with deviations in the <1s range, so use with caution
 */

state("Fusion")
{
	byte level : "fusion.exe",0x002A52D8,0xD23E;
	byte state : "fusion.exe",0x002A52D8,0xD000;
	byte endBoss : "fusion.exe",0x002A52D8,0xD2D5;
	ushort timebonus : "fusion.exe",0x002A52D8,0xD213;
	byte scorescreen : "fusion.exe",0x002A52D8,0xD22C;
	byte scorescd : "fusion.exe",0x002A52D8,0xDFEA;
	byte input : "fusion.exe",0x002A52D8,0xD203;
}

startup
{
	settings.Add("THZ1", true, "Green Hill Zone - 1");
	settings.Add("THZ2", true, "Green Hill Zone - 2");
	settings.Add("THZ3", true, "Green Hill Zone - 3");
	
	settings.Add("GZ1", true, "Bridge Zone - 1");	
	settings.Add("GZ2", true, "Bridge Zone - 2");
	settings.Add("GZ3", true, "Bridge Zone - 3");
	
	settings.Add("SEZ1", true, "Jungle  Zone - 1");
	settings.Add("SEZ2", true, "Jungle Zone - 2");
	settings.Add("SEZ3", true, "Jungle Zone - 3");
	
	settings.Add("MGHZ1", true, "Labyrinth Zone - 1");
	settings.Add("MGHZ2", true, "Labyrinth Zone - 2");
	settings.Add("MGHZ3", true, "Labyrinth Zone - 3");

	settings.Add("APZ1", true, "Scrap Brain Zone - 1");
	settings.Add("APZ2", true, "Scrap Brain Zone - 2");
	settings.Add("APZ3", true, "Scrap Brain Zone - 3");
	
	settings.Add("EEZ1", true, "Sky Base Zone - 1");
	settings.Add("EEZ2", true, "Sky Base Egg Zone - 2");
	settings.Add("EEZ3", true, "Sky Base Egg Zone - 3");
	
	Action<string> DebugOutput = (text) => {
		print("[Sonic Chaos Autosplitter] "+text);
	};
	vars.DebugOutput = DebugOutput;
}

init
{
}

exit
{
}

update
{
	return true;
}

start
{
	if (old.state == 128 && current.state == 224 && current.level == 0 && current.input != 255) {
		vars.DebugOutput("Timer started");
		return true;
	}
}

split
{
	if ((current.level != old.level && current.level <= 17)
		|| (current.endBoss==89 && old.endBoss!=89 && current.level==17))
	{
		print(current.level.ToString());
		vars.DebugOutput("Split Start of Level "+current.level);
		return true;
	}
}

isLoading
{
	if(current.timebonus >0 && current.scorescreen==27 && current.scorescd==22)
		return true;
	else
		return false;
}


